function [lamspar,tau,betanew,rho,lammp,lamip,poddp,rhop,taup]=simparlamsparse(y,ftstar_all,lamspar_old,psi,sigeps,sigeta_old,tau_old,rho_old,psilag,tau0,beta0,rho0,prior,utz);

%y=psi_i(L)x_it

N=size(y,2);
nf=size(ftstar_all,2);

lamspar=zeros(N,nf);
lammp=zeros(N,nf);
lamip=zeros(N,nf);
poddp=zeros(N,nf);
%tau=zeros(nf,1);
taup=tau0;
%rho=zeros(nf,1);
rhop=[prod(rho0,2) rho0(:,1).*(1-rho0(:,2))];
if prior~=2
    betanew=[];
else
    betanew=zeros(N,nf);
end

ftstar=ftstar_all(psilag+1:end,:,ones(1,N));

if any(psilag);
    for j=1:nf;
        ftstar(:,j,:)=lagtrans_ind(squeeze(ftstar_all(:,j,ones(1,N))),psilag,psi);
    end
end

T=min(size(ftstar,1),size(y,1));
y=y(end-T+1:end,:);
ftstar=ftstar(end-T+1:end,:,:);

%sample lamspar_ij across j
beta01=[];
beta02=[];
if prior==2;
beta01=beta0(:,1);
beta02=beta0(:,2);
end

xstar=zeros(T,N,nf);
for j=1:nf
xstar(:,:,j)=y-squeeze(sum(ftstar(:,[1:j-1 j+1:nf],:).*permute(lamspar_old(:,[1:j-1 j+1:nf],ones(1,T)),[3 2 1]),2)); % this is also useful for parallelizing simulations from the posterior
end

for j=1:nf;
    sim_ind=[(1:N)>=(1+(j-1)*utz)]';
        
    Mi= (squeeze(sum(ftstar(:,j,:).^2,1))./sigeps+(1/tau_old(j))).^-1;
    mi= Mi.*(squeeze(sum(xstar(:,:,j).*squeeze(ftstar(:,j,:)),1))'./sigeps);
    
    pp=rho_old(j);
    if prior==2
        pp=pp*beta0(j,2);
    end
    podd=log(pp/(1-pp))+pnormlog(0,0,tau_old(j))-pnormlog(zeros(N,1),mi,Mi);
    podd=min(exp(podd)./(exp(podd)+1),1.0e+06/(1.0e+06+1));
    
    lan0=(rand(N-(j-1)*utz,1)<=podd(sim_ind));
    if utz
        lan0=[zeros(j-1,1)==1;lan0];
    end
    
rhoN=sum(lan0);
lamspar(:,j)=(mi+sqrt(Mi).*randn(N,1)).*lan0;

lammp(:,j)=mi.*sim_ind;
lamip(:,j)=sqrt(Mi).*sim_ind;
poddp(:,j)=podd.*sim_ind;

if prior==2;
    podd=(1-beta0(j,2))*rho_old(j)/(1-rho_old(j));
    podd=podd/(1+podd);
    ben0= (rand(N-sum(lan0)-(j-1)*utz,1))<=podd;
    if utz
        ben0=[zeros(j-1,1)==1;ben0];
    end
    simbe=~lan0;
    simbe(simbe)=ben0;
    sb=sum(ben0);
    
    sel_mat=sparse(find(simbe),1:sb,1,N,sb);
    betanew(:,j)= sel_mat*betarnd(kron(ones(sb,1),beta01(j)*beta02(j)),kron(ones(sb,1),beta01(j)*(1-beta02(j))+1));
    sel_mat=sparse(find(lan0),1:rhoN,1,N,rhoN);
    betanew(:,j)=betanew(:,j)+ sel_mat*betarnd(kron(ones(rhoN,1),beta01(j)*beta02(j)+1),kron(ones(rhoN,1),beta01(j)*(1-beta02(j))));
    rhoN=sb+rhoN;
end

taup(j,:)=taup(j,:) + [0.5*sum(lan0) 0.5*sum((lamspar(:,j).*lan0).^2)];
%taup(j,:)=taup(j,:) + [0.5*rhoN 0.5*sum((lamspar(:,j).*lan0).^2)];

rhop(j,:)= rhop(j,:) + [ rhoN N-rhoN-(j-1)*utz];
end
tau=1./gamrnd(taup(:,1),1./taup(:,2));
rho=betarnd(rhop(:,1),rhop(:,2));





